'***************************************  Robot Setup Program  ***************************************
' File:			ROBOT_SETUP.PRG
' Purpose:		Axes setup example
' Version:		V1.0.0.0
' History:		12:30:39 28/09/2017 - V1.0.0.0 Created
' Author:		AUTOMATICALLY GENERATED by ROBOT_SETUP_Gen.py
' Description:	This script configures each robot' parameters according to the user's specifications in
'				the softMC Configurator.
'
' Global Variables Used: num_Of_Motion_Drives as long  - Number of ECat Motion Drives found by EC_SETUP.PRG
'						Axes[64] - An array that holds all the axes in the system. Defined in CONFIG.PRG
'********************************************************************************************************

' module global variables
import_c PUMA_SET_THETA(byval as long, byval as long,byval as double) as double
import_c SCARA_SET_THETA(byval as long, byval as long,byval as double) as double

common shared ROBOT_PRG_error_code as long
common shared ROBOT_PRG_error_str as string

common shared ERR_ROBOT_SETUP as error "ERROR SETTING UP robot " 20766

common shared dHomingFactorFast as double = 0.5
common shared total_dh as double
common shared dHomingFactorslow as double = 0.25
common shared dHomingFactorAcc as double = 0.1
common shared dSec2msec as double = 1000  '  this is used to convert from typical user time-units [msec] to typical drive time-units [sec]
common shared dHomingVelocity as double
common shared dHomingAcceleration as double
common shared dVelocityLimit as double
common shared dDrivePeMax as double
common shared mm_to_inch as double = 0.0393701
common shared help as double = 1

Program

dim retStr as string

	if Execute_VES("with cartXYZ", 1) <> 0 then
		throw ERR_ROBOT_SETUP
	end if

	with cartXYZ
	Attach cartXYZ

	cplg[1][1] = 1
	cplg[1][2] = 0
	cplg[1][3] = 0
	'***************************************
	cplg[2][1] = 0
	cplg[2][2] = 1
	cplg[2][3] = 0
	'***************************************
	cplg[3][1] = 0
	cplg[3][2] = 0
	cplg[3][3] = 1
	'***************************************
	j1.pmin =0
	j1.pmax =1000

	j2.pmin =0
	j2.pmax =1000

	j3.pmin =0
	j3.pmax =1000

	if Execute_VES("VelocityOverride = 100.0", 1416) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("PositionErrorMax = 10", 1417) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("SmoothFactor = -1", 1418) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("ProfilerType = -1", 1419) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("VelocityFactor = 0.001", 1420) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("AccelerationFactor = 1e-6", 1421) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("JerkFactor = 1e-6", 1422) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("VelocityMax = 1000", 1423) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("AccelerationMax = 1000", 1424) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("DecelerationMax = 1000", 1425) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("JerkMax = 15000", 1426) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("PositionErrorDelay = 4.11", 1427) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("Absolute = 1", 1428) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	configgroup

	if Execute_VES("DecStop = 1.5*DecelerationMax", 1429) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("XMax = 1000", 1430) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("XMin = -1000", 1431) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("YMax = 1000", 1432) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("YMin = -1000", 1433) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("ZMax = 1000", 1434) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("ZMin = -1000", 1435) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("RMax = 9000", 1436) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("RMin = 0", 1437) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("velocityMaxTrans = 1000", 1438) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("AccelerationMaxTrans = 10000", 1439) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("JerkMaxTrans = 100000", 1440) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("velocityTrans = 1000", 1441) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("AccelerationTrans = 10000", 1442) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("JerkTrans = 100000", 1443) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("VelocityCruise = 10", 1444) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("Acceleration = 1000", 1445) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("Deceleration = 1000", 1446) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("Jerk = 15000", 1447) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("XMax = 1000", 1448) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("XMin = -1000", 1449) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("YMax = 1000", 1450) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("YMin = -1000", 1451) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("ZMax = 1000", 1452) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	if Execute_VES("ZMin = -1000", 1453) <> 0 then
	throw ERR_ROBOT_SETUP
	end if

	detach

	if Execute_VES("end with ", 1) <> 0 then
		throw ERR_ROBOT_SETUP
	end if

	end with

End program

function Execute_VES(byval command as string, byval err_code as long) as long

	dim retStr as string

	Execute_VES = 0
	ROBOT_PRG_error_code = 0
	retStr = VesExecute(command)

	if INSTR(retStr, "E:Error") <> 0  then

		ROBOT_PRG_error_code = err_code
		ROBOT_PRG_error_str = retStr
		Execute_VES = -1

	end if

end function

